/* send.c -- Dune Webserver
 * Copyright (C) 1998 Baris Mestanogullari <mestanba@martin.luther.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <sys/stat.h>
#include <sys/dir.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <time.h>

#include "send.h"
#include "config.h"

void sendContentInfo(char *urlToSend) {
  struct direct *entry;
  struct stat fentry;
  char dir[256], size[16], lastModified[32];
  DIR *dp;
  int n;
  n=strlen(urlToSend);
  strcpy((char *)dir, urlToSend);

  while(dir[n]!='/')
    dir[n--]='\0';

  chdir(dir);
  dp=opendir(dir);

  for(entry=readdir(dp); entry!=NULL; entry=readdir(dp)) {
    buffer[0]='\0';
    strcat(buffer, dir);
    strcat(buffer, entry->d_name);
    if(!strcmp(buffer, urlToSend)) {
      stat(entry->d_name, &fentry);
      sprintf(size,"%d",(int)fentry.st_size);
      sprintf(lastModified,"%s",(char *)getmt(gmtime(&fentry.st_mtime)));
    }
  }


  sprintf(buffer, "HTTP/1.0 200 OK\r\nDate: %s\nServer: Dune/%s\r\n\
Last-Modified: %s\r\nContent-Length: %s\r\nAccept-Ranges: bytes\r\n\
Connection: close\r\n", currentTime(), VERSION, lastModified, size);
  write(cfd, buffer, strlen(buffer));
  sprintf(buffer, "Content-Type: %s\r\n\r\n", contentType(urlToSend));
  write(cfd, buffer, strlen(buffer));
}

void sendFile(char *urlToSend, int showContentInfo) {
  int count;
  urlp=fopen(urlToSend, "r");
  if(showContentInfo)
    sendContentInfo(urlToSend);
  do {
    count=fread(buffer, 1, 1024, urlp);
    write(cfd, buffer, count);
  } while(count);
  fclose(urlp);
}
